package pro.litvinovg.libreoffice.metadata;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Base64;

public class MetadataElementFactory {
	public static final String METADATA_START = "## Metadata Editor extension. Outline metadata folllows: ";
	public static String METADATA_PREFIX = "##";
	public static String METADATA_END = "## Metadata Editor extension. Outline metadata ends.";
	
	
	public static boolean isValidMetadataString(String cursorContent) {
		if (!cursorContent.startsWith(METADATA_PREFIX) || 
				cursorContent.equals(METADATA_START) ||
				cursorContent.equals(METADATA_END)){
			return false;
		}
		String data = cursorContent.substring(cursorContent.lastIndexOf(METADATA_PREFIX));
		
		return true;
	}


	public static MetadataElement fromString(String string) throws IOException, ClassNotFoundException {
		 byte [] data = Base64.getDecoder().decode( string );
     ObjectInputStream ois = new ObjectInputStream( new ByteArrayInputStream(  data ) );
     Object object  = ois.readObject();
     ois.close();
     return (MetadataElement) object;
	}
	
	private static String toString( MetadataElement object ) throws IOException {
    ByteArrayOutputStream baos = new ByteArrayOutputStream();
    ObjectOutputStream oos = new ObjectOutputStream( baos );
    oos.writeObject( object );
    oos.close();
    return Base64.getEncoder().encodeToString(baos.toByteArray()); 
	}
}
